/** @file cbitmap.cpp

	Skelton for retropc emulator

	@author Sasaji
	@date   2017.02.26 -

	@brief [ cbitmap ]
*/
#include "cbitmap.h"
#include "csurface.h"

CBitmapBase::CBitmapBase()
	: CSurface()
{
}

CBitmapBase::CBitmapBase(CBitmapBase &src, int x, int y, int w, int h)
	: CSurface()
{
	this->Copy(src, x, y, w, h);
}

CBitmapBase::~CBitmapBase()
{
}

bool CBitmapBase::Load(const _TCHAR *file_name, SDL_PixelFormat *format)
{
	return false;
}

bool CBitmapBase::Copy(CBitmapBase &src, int x, int y, int w, int h)
{
	SDL_Rect re;

	re.x = (Sint16)x;
	re.y = (Sint16)y;
	re.w = (Uint16)w;
	re.h = (Uint16)h;

	bool enable = Create(w, h, src.GetPixelFormat());
	if (enable) {
		enable = (SDL_BlitSurface(src.Get(), &re, suf, NULL) == 0);
	}
	return enable;
}
