﻿/** @file cmutex.h

	@author Sasaji
	@date   2016.11.01

	@brief mutex
*/

#ifndef _CMUTEX_H_
#define _CMUTEX_H_

#include "common.h"

#if defined(USE_WIN)
#include <Windows.h>
#elif defined(USE_SDL) || defined(USE_SDL2)
#include <SDL.h>
#elif defined(USE_WX)
#include <wx/wx.h>
#elif defined(USE_QT)
#include <QMutex.h>
#endif

class CMutex
{
private:
#if defined(USE_WIN)
	CRITICAL_SECTION cs;
#elif defined(USE_SDL) || defined(USE_SDL2)
	SDL_mutex *mux;
#elif defined(USE_WX)
	wxMutex *mux;
#elif defined(USE_QT)
	QMutex *mux;
#endif

public:
	CMutex();
	~CMutex();

	void lock();
	void unlock();
};

#endif /* _CMUTEX_H_ */
