/** @file csurface.h

	Skelton for retropc emulator

	@author Sasaji
	@date   2017.01.03 -

	@brief [ csurface ]
*/

#ifndef _CSURFACE_H_
#define _CSURFACE_H_

#include "common.h"

/**
	@brief manage CSurface
*/
class CSurface
{
protected:
	SDL_Surface *suf;

public:
	CSurface();
	CSurface(long width, long height, SDL_PixelFormat *pixel_format, int force_format = 0);
	virtual ~CSurface();

	enum enForceFormatId {
		RGBA32 = 1,	// openGL
		BGRA32,
		ARGB32,
		ABGR32
	};

	bool Create(long width, long height, SDL_PixelFormat *pixel_format, int force_format = 0);
	bool Create(VmRectWH *srcrect, SDL_PixelFormat *srcformat, int force_format = 0);
	bool Create(VmRectWH *srcrect, CSurface *srcsurface, int force_format = 0);
	void Release();

	SDL_Surface *Get();
//	operator SDL_Surface *();

	scrntype *GetBuffer();
	int GetBufferSize();
	SDL_PixelFormat *GetPixelFormat();

	bool Lock();
	void Unlock();

	bool IsEnable();

	int Width();
	int Height();
	int BitsPerPixel();
	int BytesPerPixel();
	int BytesPerLine();

	int Blit(SDL_Rect *src_re, SDL_Surface *dst, SDL_Rect *dst_re);
	int Blit(SDL_Rect *src_re, CSurface &dst, SDL_Rect *dst_re);
};

#endif
