/** @file fifo.h

	Skelton for retropc emulator

	@author Takeda.Toshiya
	@date   2006.09.17-

	@brief [ fifo buffer ]
*/

#ifndef _FIFO_H_
#define _FIFO_H_

#include "common.h"

/**
	@brief fifo buffer
*/
class FIFO
{
private:
	int* buf;
	int cnt, rpt, wpt, size;
public:
	FIFO(int s);
	void release();
	void clear();
	void write(int val);
	int read();
	int read_not_remove(int pt);
	int count();
	bool full();
	bool empty();
};

#endif

