/** @file ag_volume_dlg.h

	Skelton for retropc emulator
	SDL + Agar edition

	@author Sasaji
	@date   2012.4.5

	@brief [ ag_volume_dlg ]
*/

#ifndef _AG_VOLUME_DLG_H_
#define _AG_VOLUME_DLG_H_

#include "ag_dlg.h"

namespace GUI_AGAR
{

/**
	@brief volume dialog
*/
class AG_VOLUME_DLG : public AG_DLG {
	friend class AG_GUI_BASE;

private:
	int volume[7];
	int mute[7];

	int volmax;
	int volmin;

	void get_volume();
	void set_volume();

	// volume dialog event handler
	static void OnClose(AG_Event *);
	static void OnCancel(AG_Event *);
	static void OnChange(AG_Event *);

public:
	AG_VOLUME_DLG(EMU *, AG_GUI_BASE *);
	~AG_VOLUME_DLG();

	void Create();
	void Change();
	void Close(AG_Window *);
};

}; /* namespace GUI_AGAR */

#endif /* _AG_VOLUME_DLG_H_ */
