/** @file configpanel.h

 HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
 Skelton for retropc emulator
 SDL edition + Cocoa GUI

 @author Sasaji
 @date   2015.04.30 -

 @brief [ config panel ]
 */

#ifndef _COCOA_CONFIGPANEL_H_
#define _COCOA_CONFIGPANEL_H_

#import <Cocoa/Cocoa.h>
#import "cocoa_basepanel.h"
#import "../../vm/vm.h"
#import "../../config.h"

@interface CocoaConfigPanel : CocoaBasePanel
{
	CocoaCheckBox *chkPowerOff;
	CocoaCheckBox *chkDipswitch;
	CocoaRadioGroup *radFddType;
	CocoaCheckBox *chkFddMount[MAX_DRIVE];
	CocoaCheckBox *chkIOPort[IOPORT_NUMS];

	CocoaPopUpButton *popUseOpenGL;
	CocoaPopUpButton *popGLFilter;
	CocoaPopUpButton *popLEDShow;
	CocoaPopUpButton *popLEDPosition;
	CocoaPopUpButton *popCurdispSkew;
	CocoaPopUpButton *popDisptmgSkew;
	CocoaPopUpButton *popCaptureType;

	CocoaTextField *txtSnapPath;
	CocoaTextField *txtFontPath;
	CocoaTextField *txtMsgFontName;
	CocoaTextField *txtMsgFontSize;
	CocoaTextField *txtInfoFontName;
	CocoaTextField *txtInfoFontSize;

	CocoaCheckBox *chkReverseWave;
	CocoaCheckBox *chkHalfWave;
	CocoaCheckBox *chkCorrectWave;
	CocoaRadioGroup *radCorrect;

	CocoaCheckBox *chkDelayFd1;
	CocoaCheckBox *chkDelayFd2;

	CocoaPopUpButton *popSampleRate;
	CocoaPopUpButton *popSampleBits;

	CocoaTextField *txtLPTHost[MAX_PRINTER];
	CocoaTextField *txtLPTPort[MAX_PRINTER];
	CocoaTextField *txtCOMHost[MAX_COMM];
	CocoaTextField *txtCOMPort[MAX_COMM];
	CocoaPopUpButton *popCOMDipswitch[MAX_COMM];
#ifdef USE_DEBUGGER
	CocoaTextField *txtDbgrHost;
	CocoaTextField *txtDbgrPort;
#endif

	CocoaTextField *txtROMPath;
	CocoaCheckBox *chkExMem;
	CocoaCheckBox *chkUndefOp;
}
- (id)init;
- (NSInteger)runModal;
- (void)close;
- (void)dialogCancel:(id)sender;
- (void)dialogOk:(id)sender;
- (void)showFolderPanel:(id)sender;
- (void)showFilePanel:(id)sender;
- (void)showFontPanel:(id)sender;
- (void)changeFont:(id)sender;

- (void)selectFddType:(CocoaRadioGroup *)sender;
- (void)selectIO:(CocoaCheckBox *)sender;
- (void)selectCorrect:(CocoaCheckBox *)sender;
@end

#endif /* _COCOA_CONFIGPANEL_H_ */
