/** @file cocoa_seldrvpanel.mm
 
 HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
 Skelton for retropc emulator
 SDL edition + Cocoa GUI
 
 @author Sasaji
 @date   2015.12.12 -
 
 @brief [ select drive panel ]
 */

#import "cocoa_gui.h"
#import "cocoa_seldrvpanel.h"
#import "../../config.h"
#import "../../emu.h"
#import "../../clocale.h"

extern EMU *emu;

@implementation CocoaSelDrvPanel
@synthesize selectedDrive;
- (id)initWithPrefix:(int)defdrv prefix:(const char *)prefix
{
	[super init];

	selectedDrive = defdrv;

	self.title = [NSString stringWithUTF8String:_("Select Drive")];
	[self setShowsResizeIndicator:NO];
	
	NSRect re;
	CocoaView *view = [self contentView];
	re = [view makeRect:view.margin:view.margin:0:0];

	for(int drv=0; drv<MAX_DRIVE; drv++) {
		char label[64];
		if (prefix) {
			sprintf(label, "%s%d", prefix, drv);
		} else {
			sprintf(label, "%s%d", _("Drive"), drv);
		}
		re = [view addWidth:re:80:32];
		CocoaButton *btn = [CocoaButton create:re title:label action:@selector(dialogOk:)];
		[btn setRelatedObject:(id)(intptr_t)drv];
		[view addSubview:btn];
	}

	[self adjustFrame];

	return self;
}

- (NSInteger)runModal
{
	return [NSApp runModalForWindow:self];
}

- (void)close
{
	[NSApp stopModalWithCode:NSOKButton];
	[super close];
}

- (void)dialogOk:(id)sender
{
	CocoaButton *btn = (CocoaButton *)sender;
	selectedDrive = (int)(intptr_t)[btn relatedObject];
	[self close];
}

@end
