/** @file gtk_aboutbox.cpp

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2015.01.21 -

	@brief [ about box ]
*/

#include "gtk_aboutbox.h"
#include "../gui.h"
#include "../../version.h"

extern EMU *emu;
extern GUI *gui;

namespace GUI_GTK_X11
{

AboutBox::AboutBox(GtkWidget *parent_window)
{
	char prog_name[128];
	char prog_ver[128];
	char lib_ver[_MAX_PATH];

	sprintf(prog_name,"%s Emulator",DEVICE_NAME);
	sprintf(prog_ver,"\nVersion: %s \"%s\"%s\n",APP_VERSION,PLATFORM
#ifdef _DEBUG
		," (DEBUG)"
#else
		,""
#endif
	);
	gui->GetLibVersionString(lib_ver, _MAX_PATH);
	sprintf(&lib_ver[strlen(lib_ver)],"\nGTK+ Version %d.%d.%d",
		gtk_major_version,gtk_minor_version,gtk_micro_version);

	GdkPixbuf *icon = SetIcon();
	gtk_show_about_dialog(GTK_WINDOW(parent_window),
		"program-name", prog_name,
		"version", prog_ver,
		"copyright", APP_COPYRIGHT,
		"comments", lib_ver,
		"logo", icon,
		NULL);
	if (icon) {
		g_object_unref(icon);
	}
}

AboutBox::~AboutBox()
{
}

GdkPixbuf *AboutBox::SetIcon()
{
	char buf[_MAX_PATH];

	sprintf(buf, "%s%s.bmp", emu->resource_path(), CONFIG_NAME);
	GError *error = NULL;
	GdkPixbuf *icon = gdk_pixbuf_new_from_file(buf, &error);
	if (error) {
		g_error_free(error);
	}
	return icon;
}

}; /* namespace GUI_GTK_X11 */

