/** @file gtk_filebox.h

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2015.05.10 -

	@brief [ file box ]
*/

#ifndef _GUI_GTK_FILEBOX_H_
#define _GUI_GTK_FILEBOX_H_

#include <gtk/gtk.h>

namespace GUI_GTK_X11
{
class FileBox;

typedef void (*CbFileBox)(FileBox *, bool, void *);

class FileBox
{
private:
	GtkWidget *window;
	GtkWidget *dialog;
	char *selected_file;
	CbFileBox cb_handler;
	void *cb_data;

	void parse_filter(GtkFileChooser *chooser, const char *filter_list[]);

	static void OnResponse(GtkWidget *widget, gint response_id, gpointer user_data);

public:
	FileBox();
	~FileBox();
	bool Show(GtkWidget *parent_window, const char *filter[], const char *title, const char *dir, const char *ext, bool save, const char *path = NULL, CbFileBox callback_handler = NULL, void *callback_data = NULL);
	void Hide();

	const char *GetPath();
};

}; /* namespace GUI_GTK_X11 */

#endif /* _GUI_GTK_FILEBOX_H_ */
