/** @file gui.h

	Skelton for retropc emulator
	SDL edition

	@author Sasaji
	@date   2015.04.01

	@brief [ gui ]
*/

#ifndef _GUI_H_
#define _GUI_H_

#if defined(GUI_TYPE_AGAR)

#include "agar/ag_gui.h"

#elif defined(GUI_TYPE_WINDOWS)

#define NOT_USE_GETTEXT_ACP 1
#include "windows/win_gui.h"

#elif defined(GUI_TYPE_COCOA)

#include "cocoa/cocoa_gui.h"

#elif defined(GUI_TYPE_GTK_X11)

#include "gtk_x11/gtk_x11_gui.h"

#else

#include "gui_base.h"

class GUI : public GUI_BASE
{
public:
	GUI(int argc, char **argv, EMU *new_emu) : GUI_BASE(argc, argv, new_emu) {}
};

#endif

#endif /* _GUI_H_ */
