/** @file win_aboutbox.cpp

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2015.01.21 -

	@brief [ about box ]
*/

#include "win_aboutbox.h"
#include "../gui.h"
#include "../../version.h"

namespace GUI_WIN
{

AboutBox::AboutBox(HINSTANCE hinst, CFont *new_font, EMU *new_emu, GUI *new_gui)
	: CDialogBox(hinst, IDD_ABOUTBOX, new_font, new_emu, new_gui)
{
}

AboutBox::~AboutBox()
{
}

INT_PTR AboutBox::onInitDialog(UINT message, WPARAM wParam, LPARAM lParam)
{
	CDialogBox::onInitDialog(message, wParam, lParam);

	RECT re;
	re.left = margin + 16;
	re.top = margin + 16;
	AdjustControl(IDC_STATIC_1, &re, 32, 32);
	LONG bottom = re.bottom;
	re.left = re.right + 16 + margin;
	re.top = margin;
	AdjustStatic(IDC_STATIC_2, &re);
	// version
	char buf[_MAX_PATH];
	sprintf(buf, "Version %s \"%s\"", APP_VERSION, PLATFORM);
	SetWindowTextA(GetDlgItem(hDlg, IDC_STATIC_3), buf);
	re.top = re.bottom + margin;
	AdjustStatic(IDC_STATIC_3, &re);
	sprintf(buf, "%s%s"
#ifdef USE_DEBUGGER
		," with Debugger"
#else
		,""
#endif
#ifdef _DEBUG
		," (DEBUG Version)"
#else
		,""
#endif
	);
	if (buf[0] != '\0') {
		SetWindowTextA(GetDlgItem(hDlg, IDC_STATIC_4), buf);
		re.top = re.bottom;
		AdjustStatic(IDC_STATIC_4, &re);
	}
#if defined(USE_SDL) || defined(USE_SDL2)
	gui->GetLibVersionString(buf, _MAX_PATH, _T(", "));
	SetWindowTextA(GetDlgItem(hDlg, IDC_STATIC_5), buf);
#endif
	re.top = re.bottom + margin;
	AdjustStatic(IDC_STATIC_5, &re);
#if defined(USE_SDL) || defined(USE_SDL2)
	re.top = re.bottom + margin;
	AdjustStatic(IDC_STATIC_6, &re);
#endif
	AdjustWindow(0);

	re.top = (bottom > re.bottom ? bottom : re.bottom) + margin;
	re.right = re_max.right;
	AdjustButton(IDOK, 8, &re, true);

	AdjustWindow(margin);

	return (INT_PTR)TRUE;
}

}; /* namespace GUI_WIN */
