/** @file win_keybindbox.h

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2012.03.31 -

	@brief [ keybind box ]
*/

#ifndef _KEYBINDBOX_H_
#define _KEYBINDBOX_H_

#include <windows.h>
#include "win_keybindctrl.h"
#include "win_dialogbox.h"

class EMU;

namespace GUI_WIN
{

/**
	@brief keybind dialog
*/
class KeybindBox : public CDialogBox
{
private:
	KeybindControl *kbctl[KEYBIND_MAX_NUM];

	int selected_tabctrl;

	INT_PTR onInitDialog(UINT message, WPARAM wParam, LPARAM lParam);
	INT_PTR onCommand(UINT message, WPARAM wParam, LPARAM lParam);
	INT_PTR onNotify(UINT message, WPARAM wParam, LPARAM lParam);
	INT_PTR onMouseWheel(UINT message, WPARAM wParam, LPARAM lParam);
//	INT_PTR onControlColorStatic(UINT, WPARAM, LPARAM);
	INT_PTR onClickOk();
	INT_PTR onClickLoadDefault();
	INT_PTR onClickLoadPreset(int idx);
	INT_PTR onClickSavePreset(int idx);

	void select_tabctrl(int tab_num);

public:
	KeybindBox(HINSTANCE, CFont *, EMU *, GUI *);
	~KeybindBox();

//	void SetTitleLabel(const _TCHAR *vm, const _TCHAR *vk, const _TCHAR *vj);
};

}; /* namespace GUI_WIN */

#endif /* _KEYBINDBOX_H_ */
