/** @file win_seldrvbox.cpp

	Skelton for retropc emulator

	@author Sasaji
	@date   2015.12.06 -

	@brief [ select drive box ]
*/

#include "win_seldrvbox.h"
#include "../../emu.h"
#include <commctrl.h>

namespace GUI_WIN
{

#define IDC_BUTTON	42101

SelDrvBox::SelDrvBox(HINSTANCE hInst, CFont *new_font, EMU *new_emu, GUI *new_gui)
	: CDialogBox(hInst, IDD_SELDRVBOX, new_font, new_emu, new_gui)
{
	def_drv = 0;
	memset(prefix, 0, sizeof(prefix));
	_tcscpy(prefix, _TX("Drive"));
}

SelDrvBox::~SelDrvBox()
{
}

INT_PTR SelDrvBox::onInitDialog(UINT message, WPARAM wParam, LPARAM lParam)
{
	CDialogBox::onInitDialog(message, wParam, lParam);

	// layout
	_TCHAR label[64];

	RECT re;
	re.top = margin;
	re.left = margin;
	re.bottom = re.top + 1;
	re.right = re.left + 1;

	// button
	for(int drv=0; drv<MAX_DRIVE; drv++) {
		UTILITY::sprintf_utf8(label, 64, _T("%s%d"), prefix, drv);
		CreateButton(IDC_BUTTON+drv, label, 6, &re, false);
		re.left = re.right;
	}
	AdjustWindow(margin);

	return (INT_PTR)TRUE;
}

INT_PTR SelDrvBox::onCommand(UINT message, WPARAM wParam, LPARAM lParam)
{
	int id = (int)LOWORD(wParam);
	if (id >= IDC_BUTTON && id < (IDC_BUTTON + MAX_DRIVE)) {
		::EndDialog(hDlg, id - IDC_BUTTON);
		hDlg = NULL;
		return (INT_PTR)TRUE;
	}
	return (INT_PTR)FALSE;
}

void SelDrvBox::SetDrive(int val)
{
	def_drv = val;
}

void SelDrvBox::SetPrefix(const _TCHAR *val)
{
	memset(prefix, 0, sizeof(prefix));
	_tcsncpy(prefix, val, sizeof(prefix) - 1);
}

}; /* namespace GUI_WIN */
