/** @file win_vkeyboard.h

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2016.12.21 -

	@brief [ virtual keyboard ]
*/

#ifndef _WIN_VKEYBOARD_H_
#define _WIN_VKEYBOARD_H_

#include <windows.h>
#include <windowsx.h>
#include "../../res/resource.h"
#include "../vkeyboard.h"

namespace Vkbd {

class VKeyboard : public Base
{
private:
	HINSTANCE	hInstance;

	HWND		hVkbd;
	HWND		hParent;

	HDC			hSufDC;
	HBITMAP		hSufBmp;
	BITMAPINFO	bmiSuf;

	void adjust_window_size();
	void set_dist();
	void need_update_window(PressedInfo_t *, bool);
	void update_window();
	void init_dialog(HWND);
	void paint_window(HDC, RECT *);

	static INT_PTR CALLBACK Proc(HWND, UINT, WPARAM, LPARAM);

public:
	VKeyboard(HINSTANCE, HWND);
	~VKeyboard();

	void Create(const _TCHAR *res_path);
	void Show(bool = true);
	void Close();
};

} /* namespace Vkbd */

#endif /* _WIN_VKEYBOARD_H_ */
