/** @file sdl_utils.h

 Skelton for retropc emulator
 SDL edition

 @author Sasaji
 @date   2015.05.20

 @brief [ sdl utilities ]

 */

#ifndef _SDL_UTILS_H_
#define _SDL_UTILS_H_

#include "common.h"
#include <SDL.h>

namespace SDL_UTILS
{

int blit_surface(SDL_Surface *src, VmRectWH *srcrect, SDL_Surface *dst, VmRectWH *dstrect);

void copy_surface(SDL_Surface *src, SDL_Rect *reSrc, SDL_Surface *dst, SDL_Rect *reDst);
void copy_surface(SDL_Surface *src, VmRectWH *reSrc, SDL_Surface *dst, VmRectWH *reDst);
void copy_surface_flipped(SDL_Surface *src, SDL_Rect *reSrc, SDL_Surface *dst, SDL_Rect *reDst);
void copy_surface_flipped(SDL_Surface *src, VmRectWH *reSrc, SDL_Surface *dst, VmRectWH *reDst);
void zoomin_surface(SDL_Surface *src, SDL_Rect *reSrc, SDL_Surface *dst, SDL_Rect *reDst);
void zoomin_surface(SDL_Surface *src, VmRectWH *reSrc, SDL_Surface *dst, VmRectWH *reDst);
void zoomin_surface_flipped(SDL_Surface *src, SDL_Rect *reSrc, SDL_Surface *dst, SDL_Rect *reDst);
void zoomin_surface_flipped(SDL_Surface *src, VmRectWH *reSrc, SDL_Surface *dst, VmRectWH *reDst);
void fill_surface(SDL_Surface *src, scrntype data, scrntype mask);

SDL_Surface *create_surface(SDL_Rect *srcrect, SDL_PixelFormat *srcformat, int force_format = 0);
SDL_Surface *create_surface(VmRectWH *srcrect, SDL_PixelFormat *srcformat, int force_format = 0);
SDL_Surface *create_surface(SDL_Rect *srcrect, SDL_Surface *srcsurface, int force_format = 0);
SDL_Surface *create_surface(VmRectWH *srcrect, SDL_Surface *srcsurface, int force_format = 0);
SDL_Surface *release_surface(SDL_Surface *surface);

void set_pixel_format_for_opengl(SDL_PixelFormat *pixel_format);
void set_pixel_format_bgra(SDL_PixelFormat *pixel_format);
void set_pixel_format_argb(SDL_PixelFormat *pixel_format);
void set_pixel_format_rgba(SDL_PixelFormat *pixel_format);

}; /* SDL_UTILS */

#endif /* _SDL_UTILS_H_ */
