/** @file display.cpp

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2011.06.08 -

	@brief [ display sub ]
*/

#ifdef _DISPLAY_H_

{
	// interace or videomode
	dws_int_vid = ((interlace_sel) + (1 - (*videomode)));

	// odd line ?
	switch(scanline) {
	case 3:
	case 2:
		dws_yd = (sw & 1);
		break;
	case 1:
		dws_yd = ((regs[8] & 1) == 1 && ((sw ^ screen_top) & 1) == 0 ? 1 : 0);
		break;
	default:
		dws_yd = 0;
		break;
	}

	// set y axis position from the kind of drawing line
	SET_YAXIS_POSITION;

//emu->out_logf(LOG_DEBUG,_T("ii0:%d ii1:%d"),ii[0],ii[1]);
//for(i = 0; i < 3; i++) {
//	emu->out_logf(LOG_DEBUG,_T(" y:%d y0:%d y1:%d"),i,y0[i],y1[i]);
//}

	// out of disptmg area (top or bottom padding area)
	for(dws_i = 0; dws_i < dws_ii[0]; dws_i++) {
		dws_buf_y = - top_raster + (VRAM_BUF_HEIGHT << 1) + dws_y0[dws_i];

		INIT_SCRN_DOT(dws_y0[dws_i]);
		INIT_SCRNLINE1(dws_y0[dws_i]);

		for(dws_y = dws_y0[dws_i]; dws_y < dws_y1[dws_i]; ) {
			dws_buf_y_h = ((dws_buf_y >> 1) % VRAM_BUF_HEIGHT);
			dws_p_vline = &crt_mon_vline[dws_buf_y_h];

			dws_x0 = screen_left;
			if (buf_stepcols > 1) {
				dws_xodd = ((dws_buf_y_h + (sw >> 1)) & 1);
				dws_x0 += dws_xodd;
			}

			if (vsync_top_raster <= dws_y && dws_y < vsync_bottom_raster) {
				for(dws_x = dws_x0; dws_x < screen_right; dws_x += buf_stepcols) {
					dws_scrn[dws_x] = SET_SCRN_DOT(dws_x, palette_pc[0]);
				}
			} else {
				for(dws_x = dws_x0; dws_x < screen_right; dws_x += buf_stepcols) {
					if (dws_p_vline->hsync_left_col <= dws_x && dws_x < dws_p_vline->hsync_right_col) {
						dws_scrn[dws_x] = SET_SCRN_DOT(dws_x, palette_pc[0]);
					} else {
						dws_scrn[dws_x] = SET_SCRN_DOT(dws_x, palette_pc[bg_color]);
					}
				}
			}
			dws_y+=dws_ys;
			dws_buf_y+=dws_ys;
			ADD_SCRN_DOT;
			ADD_SCRNLINE1;
		}
	}

	// disptmp area
	for(dws_i = dws_ii[0]; dws_i < dws_ii[1]; dws_i++) {
		dws_buf_y = - top_raster + ((crt_mon_start_row + VRAM_BUF_HEIGHT) << 1) + dws_y0[dws_i];
		INIT_SCRN_DOT(dws_y0[dws_i]);
		INIT_SCRNLINE1(dws_y0[dws_i]);
//		dws_l = (crt_mon_start_raster + (top_raster <= bottom_raster ? 0 : dws_raster_per_char - ((bottom_raster - 1) % dws_raster_per_char) - 1)) | dws_yd;
		dws_l = (crt_mon_vline[(dws_buf_y >> 1) % VRAM_BUF_HEIGHT].raster & ~0x81) | dws_yd;

		for(dws_y = dws_y0[dws_i]; dws_y < dws_y1[dws_i]; ) {
			dws_buf_y_h = ((dws_buf_y >> 1) % VRAM_BUF_HEIGHT);
			dws_p_crt_mon = crt_mon[dws_buf_y_h];
			dws_p_vline = &crt_mon_vline[dws_buf_y_h];

			dws_buf_x = dws_p_vline->left_col < 0 ? - dws_p_vline->left_col / crtc_ppch : 0 ;
			dws_x0 = screen_left;
			dws_x1 = (screen_right < dws_p_vline->left_col ? screen_right : dws_p_vline->left_col);
			dws_x2 = (screen_left > dws_p_vline->left_col ? screen_left : dws_p_vline->left_col);
			dws_x3 = (screen_right < dws_p_vline->right_col ? screen_right : dws_p_vline->right_col);
			dws_x4 = dws_x3;
			dws_xodd = 0;
			if (buf_stepcols > 1) {
				dws_xodd = ((dws_buf_y_h + (sw >> 1)) & 1);
				dws_buf_x += dws_xodd;
				dws_x0 += dws_xodd;
				dws_x2 += (dws_xodd * crtc_ppch);
				dws_x4 += dws_xodd;
			}

			// cursor line ?
			dws_disp_cursor_line = (disp_cursor && cur_top <= dws_y && dws_y <= cur_bottom);

			// out of disptmg area (left padding area)
			for(dws_x = dws_x0; dws_x < dws_x1; ) {
				DISP_OUT_OF_DISPTMG(dws_p_vline, dws_x);
				dws_x += buf_stepcols;
			}
			// out of disptmg area (right padding area)
			for(dws_x = dws_x4; dws_x < screen_right; ) {
				DISP_OUT_OF_DISPTMG(dws_p_vline, dws_x);
				dws_x += buf_stepcols;
			}

			// disptmg area
#ifdef DEBUG_CRTMON
			if (dws_buf_y_h < 2) {
				emu->out_debugf(_T("DISPLAY:draw_sub: sw:%d bufyh:%d bufx:%d x0:%d txt:%02x")
					,sw, dws_buf_y_h, dws_buf_x, dws_x0, dws_p_crt_mon[dws_buf_x].text
				);
			}
#endif
			for(dws_x = dws_x2; dws_x < dws_x3; ) {
				dws_disp_cursor_char = (dws_disp_cursor_line && cur_left[dws_l] <= dws_x && dws_x < cur_right[dws_l]);

				dws_code = dws_p_crt_mon[dws_buf_x].text;
				dws_cram = dws_p_crt_mon[dws_buf_x].attr;
				dws_ki = dws_cram & 0x80 ? true : false;
				dws_c_f = dws_cram & 0x07;
				dws_c_b = bg_color;
				dws_ck_f = dws_c_f;
				dws_ck_b = 0;
				// color reverse
				if ((dws_cram & 0x28) == 0x08) {
					COLOR_REVERSE(dws_c_f, dws_c_b);
					if (dws_ki) {
						COLOR_REVERSE(dws_ck_f, dws_ck_b);
					}
				}

				switch(dws_cram & 0x30) {
				case 0x30:
				case 0x20:
					// ig
					if (!ig_enable) {
						// disp ig pattern
						DISP_IG_PATTERN;
					} else {
						// disp white square
						DISP_WHITE_SPACE;
					}
					break;
				case 0x10:
					// graphic
					dws_p = dws_code;

					if (dws_disp_cursor_char) COLOR_REVERSE(dws_c_f, dws_c_b);
					if (dws_cram & 0x40) {
						// hireso graphic
						DISP_GRAPHIC_HIRESO;
					} else {
						// normal graphic
						DISP_GRAPHIC_NORMAL;
					}
					break;
				default:
					// character
					DISP_TEXT_CHAR;
					break;
				}
				dws_x += (crtc_ppch * buf_stepcols);
				dws_buf_x += buf_stepcols;
			}

			dws_y+=dws_ys;
			dws_buf_y+=dws_ys;
			ADD_SCRN_DOT;
			ADD_SCRNLINE1;
			dws_l = ((dws_l + dws_ys) % dws_raster_per_char);
		}
	}

	// clear non drawing line
	if (scanline == 1) {
		dws_yd = 1 - dws_yd;
		INIT_SCRN_DOT(screen_top | dws_yd);
		INIT_SCRNLINE1(screen_top | dws_yd);
		for(dws_y = (screen_top | dws_yd); dws_y < screen_bottom; ) {
			for(dws_x = screen_left; dws_x < screen_right; dws_x++) {
				dws_scrn[dws_x] = SET_SCRN_DOT(dws_x, palette_pc[0]);
			}
			dws_y+=dws_ys;
			ADD_SCRN_DOT;
			ADD_SCRNLINE1;
		}
	}

#ifdef USE_KEEPIMAGE
	// overlap the top most screen if need
	if (keepimage > 0) {
		dws_scrn = emu->screen_buffer(screen_top);
		for(dws_y = screen_top; dws_y < screen_bottom; dws_y++) {
			for(dws_x = screen_left; dws_x < screen_right; dws_x++) {
				if (scrntop[dws_y][dws_x] != palette_pc[0]) dws_scrn[dws_x] = scrntop[dws_y][dws_x];
			}
			dws_scrn += dws_scrn_offset;
		}
	}
#endif
}

#endif /* _DISPLAY_H_ */
