// ---------------------------------------------------------------------------
//	OPM-like Sound Generator
//	Copyright (C) cisc 1998, 2003.
// ---------------------------------------------------------------------------
//	$Id: opm.h,v 1.14 2003/06/07 08:25:53 cisc Exp $

#ifndef FM_OPM_H
#define FM_OPM_H

#include "fmgen.h"
#include "fmtimer.h"
#include "psg.h"

#ifdef HAS_YM2151
#define BUILD_OPM
#endif

// ---------------------------------------------------------------------------
//	class OPM
//	OPM ɗǂ(?)𐶐鉹jbg
//
//	interface:
//	bool Init(uint32_t clock, uint32_t rate, bool);
//		D̃NXgpOɂȂ炸ĂłƁD
//		: `⊮[h͔p~܂
//
//		clock:	OPM ̃NbNg(Hz)
//
//		rate:	 PCM ̕W{g(Hz)
//
//
//		Ԓl	ɐ true
//
//	bool SetRate(uint32_t clock, uint32_t rate, bool)
//		NbN PCM [gύX
//		 Init ƓlD
//
//	void Mix(Sample* dest, int nsamples)
//		Stereo PCM f[^ nsamples C dest Ŏn܂z
//		(Z)
//		Edest ɂ sample*2 ̗̈悪Kv
//		Ei[` L, R, L, R... ƂȂD
//		E܂ŉZȂ̂ŁC炩ߔz[NAKv
//		EFM_SAMPLETYPE  short ^̏ꍇNbsOs.
//		E̊֐͉̃^C}[Ƃ͓ƗĂD
//		  Timer  Count  GetNextEvent ő삷KvD
//
//	void Reset()
//		Zbg()
//
//	void SetReg(uint32_t reg, uint32_t data)
//		̃WX^ reg  data 
//
//	uint32_t ReadStatus()
//		̃Xe[^XWX^ǂݏo
//		busy tO͏ 0
//
//	bool ReadIRQ()
//		IRQ o͂ǂݏo
//
//	bool Count(uint32_t t)
//		̃^C}[ t [clock] i߂D
//		̓Ԃɕω(timer I[o[t[)
//		true Ԃ
//
//	uint32_t GetNextEvent()
//		̃^C}[̂ǂ炩I[o[t[܂łɕKv
//		[clock]Ԃ
//		^C}[~Ăꍇ 0 ԂD
//
//	void SetVolume(int db_l, int db_r)
//		ẻʂ{|ɒ߂DWl 0.
//		Pʂ͖ 1/2 dBCL͈͂̏ 20 (10dB)
//
namespace FM
{
#ifdef BUILD_OPM
	//	YM2151(OPM) ----------------------------------------------------
	class OPM : public Timer
	{
	public:
		OPM();
		~OPM() {}

		bool	Init(uint32_t c, uint32_t r, bool=false);
		bool	SetRate(uint32_t c, uint32_t r, bool);
		void	SetLPFCutoff(uint32_t freq);
		void	Reset();
		bool	ReadIRQ();

		void 	SetReg(uint32_t addr, uint32_t data);
		uint32_t	GetReg(uint32_t addr);
		uint32_t	ReadStatus() { return status & 0x03; }

		void 	Mix(Sample* buffer, int nsamples);

		void	SetVolume(int db_l, int db_r);
		void	SetChannelMask(uint32_t mask);
		
		void SaveState(void *f, size_t *size);
		bool LoadState(void *f);
		
	private:
		void	Intr(bool value);

	private:
		enum
		{
			OPM_LFOENTS = 512,
		};

		void	SetStatus(uint32_t bit);
		void	ResetStatus(uint32_t bit);
		void	SetParameter(uint32_t addr, uint32_t data);
		void	TimerA();
		void	RebuildTimeTable();
		void	MixSub(int activech, ISample**);
		void	MixSubL(int activech, ISample**);
		void	LFO();
		uint32_t	Noise();
		
		int		fmvolume_l;
#ifdef USE_FMGEN_STEREO
		int		fmvolume_r;
#endif

		uint32_t	clock;
		uint32_t	rate;
		uint32_t	pcmrate;

		uint32_t	pmd;
		uint32_t	amd;
		uint32_t	lfocount;
		uint32_t	lfodcount;

		uint32_t	lfo_count_;
		uint32_t	lfo_count_diff_;
		uint32_t	lfo_step_;
		uint32_t	lfo_count_prev_;

		uint32_t	lfowaveform;
		uint32_t	rateratio;
		uint32_t	noise;
		int32_t		noisecount;
		uint32_t	noisedelta;

		bool	interpolation;
		uint8_t	lfofreq;
		uint8_t	status;
		bool	interrupt;
		uint8_t	reg01;

		uint8_t	kc[8];
		uint8_t	kf[8];
		uint8_t	pan[8];

		Channel4 ch[8];
		Chip	chip;

		static void	BuildLFOTable();
		static int amtable[4][OPM_LFOENTS];
		static int pmtable[4][OPM_LFOENTS];

	public:
		int		dbgGetOpOut(int c, int s) { return ch[c].op[s].dbgopout_; }
		Channel4* dbgGetCh(int c) { return &ch[c]; }

	};
#endif /* BUILD_OPM */
}

#endif // FM_OPM_H
