// ---------------------------------------------------------------------------
//	OPN/A/B interface with ADPCM support
//	Copyright (C) cisc 1998, 2003.
// ---------------------------------------------------------------------------
//	$Id: opna.h,v 1.33 2003/06/12 13:14:37 cisc Exp $

#ifndef FM_OPNA_H
#define FM_OPNA_H

#include "../../depend.h"
#include "fmgen.h"
#include "fmtimer.h"
#include "psg.h"

#define BUILD_OPN

#ifdef HAS_YM2608
#define BUILD_OPNA
#endif
#ifdef HAS_YM2610
#define BUILD_OPNB
#endif

// ---------------------------------------------------------------------------
//	class OPN/OPNA
//	OPN/OPNA ɗǂ𐶐鉹jbg
//
//	interface:
//	bool Init(uint32_t clock, uint32_t rate, bool, const _TCHAR* path);
//		D̃NXgpOɂȂ炸ĂłƁD
//		OPNA ̏ꍇ͂̊֐ŃYTvǂݍ
//
//		clock:	OPN/OPNA/OPNB ̃NbNg(Hz)
//
//		rate:	 PCM ̕W{g(Hz)
//
//		path:	YTṽpX(OPNA ̂ݗL)
//				ȗ̓JgfBNgǂݍ
//				̖ɂ '\'  '/' Ȃǂ邱
//
//		Ԃl	ɐ true
//
//	bool LoadRhythmSample(const _TCHAR* path)
//		(OPNA ONLY)
//		Rhythm TvǂݒD
//		path  Init  path ƓD
//
//	bool SetRate(uint32_t clock, uint32_t rate, bool)
//		NbN PCM [gύX
//		 Init QƂ̂ƁD
//
//	void Mix(FM_SAMPLETYPE* dest, int nsamples)
//		Stereo PCM f[^ nsamples C dest Ŏn܂z
//		(Z)
//		Edest ɂ sample*2 ̗̈悪Kv
//		Ei[` L, R, L, R... ƂȂD
//		E܂ŉZȂ̂ŁC炩ߔz[NAKv
//		EFM_SAMPLETYPE  short ^̏ꍇNbsOs.
//		E̊֐͉̃^C}[Ƃ͓ƗĂD
//		  Timer  Count  GetNextEvent ő삷KvD
//
//	void Reset()
//		Zbg()
//
//	void SetReg(uint32_t reg, uint32_t data)
//		̃WX^ reg  data 
//
//	uint32_t GetReg(uint32_t reg)
//		̃WX^ reg ̓eǂݏo
//		ǂݍނƂo郌WX^ PSG, ADPCM ̈ꕔCID(0xff) Ƃ
//
//	uint32_t ReadStatus()/ReadStatusEx()
//		̃Xe[^XWX^ǂݏo
//		ReadStatusEx ͊gXe[^XWX^̓ǂݏo(OPNA)
//		busy tO͏ 0
//
//	bool ReadIRQ()
//		IRQ o͂ǂݏo
//
//	bool Count(uint32_t t)
//		̃^C}[ t [clock] i߂D
//		̓Ԃɕω(timer I[o[t[)
//		true Ԃ
//
//	uint32_t GetNextEvent()
//		̃^C}[̂ǂ炩I[o[t[܂łɕKv
//		[clock]Ԃ
//		^C}[~Ăꍇ ULONG_MAX Ԃc Ǝv
//
//	void SetVolumeFM(int db_l, int db_r)/SetVolumePSG(int db_l, int db_r) ...
//		ẻʂ{|ɒ߂DWl 0.
//		Pʂ͖ 1/2 dBCL͈͂̏ 20 (10dB)
//
namespace FM
{
	//	OPN Base -------------------------------------------------------
	class OPNBase : public Timer
	{
	public:
		OPNBase();
		virtual ~OPNBase() {}

		bool	Init(uint32_t c, uint32_t r);
		virtual void Reset();
		bool	ReadIRQ();

		void	SetVolumeFM(int db_l, int db_r);
		void	SetVolumePSG(int db_l, int db_r, int ptn);
		void	SetLPFCutoff(uint32_t freq) {}	// obsolete

	protected:
		void	SetParameter(Channel4* ch, uint32_t addr, uint32_t data);
		void	SetPrescaler(uint32_t p);
		void	RebuildTimeTable();
		void	Intr(bool value);
		
		void SaveState(void *f, size_t *size);
		bool LoadState(void *f);
		
		int		fmvolume_l;
#ifdef USE_FMGEN_STEREO
		int		fmvolume_r;
#endif
		
		uint32_t	clock;				// OPN NbN
		uint32_t	rate;				// FM [g
		uint32_t	psgrate;			// FMGen  o̓[g
		uint32_t	status;
		bool	interrupt;
		Channel4* csmch;


#if defined(BUILD_OPNA) || defined (BUILD_OPNB)
		static  uint32_t lfotable[8];
#endif

	private:
		void	TimerA();
		uint8_t	prescale;

	protected:
		Chip	chip;
		PSG		psg;
	};

#if defined(BUILD_OPNA) || defined(BUILD_OPNB)
	//	OPN2 Base ------------------------------------------------------
	class OPNABase : public OPNBase
	{
	public:
		OPNABase();
		~OPNABase();

		uint32_t	ReadStatus() { return status & 0x03; }
		uint32_t	ReadStatusEx();
		void	SetChannelMask(uint32_t mask);

	private:
		void	MakeTable2();

	protected:
		bool	Init(uint32_t c, uint32_t r, bool);
		bool	SetRate(uint32_t c, uint32_t r, bool);

		void	Reset();
		void 	SetReg(uint32_t addr, uint32_t data);
		void	SetADPCMBReg(uint32_t reg, uint32_t data);
		uint32_t	GetReg(uint32_t addr);

		void SaveState(void *f, size_t *size);
		bool LoadState(void *f);

	protected:
		void	FMMix(Sample* buffer, int nsamples);
		void 	Mix6(Sample* buffer, int nsamples, int activech);

		void	MixSubS(int activech, ISample**);
		void	MixSubSL(int activech, ISample**);

		void	SetStatus(uint32_t bit);
		void	ResetStatus(uint32_t bit);
		void	UpdateStatus();
		void	LFO();

		void	DecodeADPCMB();
		void	ADPCMBMix(Sample* dest, uint32_t count);

		void	WriteRAM(uint32_t data);
		uint32_t	ReadRAM();
		int		ReadRAMN();
		int		DecodeADPCMBSample(uint32_t);

	// FM ֌W
		uint8_t	pan[6];
		uint8_t	fnum2[9];

		uint8_t	reg22;
		uint32_t	reg29;		// OPNA only?

		uint32_t	stmask;
		uint32_t	statusnext;

		uint32_t	lfocount;
		uint32_t	lfodcount;

		uint32_t	fnum[6];
		uint32_t	fnum3[3];

	// ADPCM ֌W
		uint8_t*	adpcmbuf;		// ADPCM RAM
		uint32_t	adpcmmask;		// AhXɑ΂rbg}XN
		uint32_t	adpcmnotice;	// ADPCM ĐIɂrbg
		uint32_t	startaddr;		// Start address
		uint32_t	stopaddr;		// Stop address
		uint32_t	memaddr;		// ĐAhX
		uint32_t	limitaddr;		// Limit address/mask
		int		adpcmlevel;		// ADPCM 
		int		adpcmvolume_l;
		int		adpcmvol_l;
		uint32_t	deltan;			// N
		int		adplc;			// gϊpϐ
		int		adpld;			// gϊpϐl
		uint32_t	adplbase;		// adpld ̌
		int		adpcmx;			// ADPCM p x
		int		adpcmd;			// ADPCM p 
		int		adpcmout_l;		// ADPCM ̏o
		int		apout0_l;			// out(t-2)+out(t-1)
		int		apout1_l;			// out(t-1)+out(t)

#ifdef USE_FMGEN_STEREO
		int		adpcmvolume_r;
		int		adpcmvol_r;
		int		adpcmout_r;		// ADPCM ̏o
		int		apout0_r;			// out(t-2)+out(t-1)
		int		apout1_r;			// out(t-1)+out(t)
#endif

		uint32_t	adpcmreadbuf;	// ADPCM [hpobt@
		bool	adpcmplay;		// ADPCM Đ
		int8_t	granuality;
		bool	adpcmmask_;

		uint8_t	control1;		// ADPCM Rg[WX^P
		uint8_t	control2;		// ADPCM Rg[WX^Q
		uint8_t	adpcmreg[8];	// ADPCM WX^̈ꕔ

		int		rhythmmask_;

		Channel4 ch[6];

		static void	BuildLFOTable();
		static int amtable[FM_LFOENTS];
		static int pmtable[FM_LFOENTS];
		static int32_t tltable[FM_TLENTS+FM_TLPOS];
		static bool	tablehasmade;
	};
#endif /* BUILD_OPNA || BUILD_OPNB */

	//	YM2203(OPN) ----------------------------------------------------
	class OPN : public OPNBase
	{
	public:
		OPN();
		virtual ~OPN() {}

		bool	Init(uint32_t c, uint32_t r, bool=false, const char* =0);
		bool	SetRate(uint32_t c, uint32_t r, bool=false);

		void	Reset();
		void 	Mix(Sample* buffer, int nsamples);
		void 	SetReg(uint32_t addr, uint32_t data);
		uint32_t	GetReg(uint32_t addr);
		uint32_t	ReadStatus() { return status & 0x03; }
		uint32_t	ReadStatusEx() { return 0xff; }

		void	SetChannelMask(uint32_t mask);

		int		dbgGetOpOut(int c, int s) { return ch[c].op[s].dbgopout_; }
		int		dbgGetPGOut(int c, int s) { return ch[c].op[s].dbgpgout_; }
		Channel4* dbgGetCh(int c) { return &ch[c]; }
		
		void SaveState(void *f, size_t *size);
		bool LoadState(void *f);
	
	private:
		void	SetStatus(uint32_t bit);
		void	ResetStatus(uint32_t bit);

		uint32_t	fnum[3];
		uint32_t	fnum3[3];
		uint8_t	fnum2[6];

		Channel4 ch[3];
	};

#ifdef BUILD_OPNA
	//	YM2608(OPNA) ---------------------------------------------------
	class OPNA : public OPNABase
	{
	public:
		OPNA();
		virtual ~OPNA();

		bool	Init(uint32_t c, uint32_t r, bool  = false, const _TCHAR* rhythmpath=0);
		bool	LoadRhythmSample(const _TCHAR*);

		bool	SetRate(uint32_t c, uint32_t r, bool = false);
		void 	Mix(Sample* buffer, int nsamples);

		void	Reset();
		void 	SetReg(uint32_t addr, uint32_t data);
		uint32_t	GetReg(uint32_t addr);

		void	SetVolumeADPCM(int db_l, int db_r);
		void	SetVolumeRhythmTotal(int db_l, int db_r);
		void	SetVolumeRhythm(int index, int db_l, int db_r);

		uint8_t*	GetADPCMBuffer() { return adpcmbuf; }

		int		dbgGetOpOut(int c, int s) { return ch[c].op[s].dbgopout_; }
		int		dbgGetPGOut(int c, int s) { return ch[c].op[s].dbgpgout_; }
		Channel4* dbgGetCh(int c) { return &ch[c]; }

		void SaveState(void *f, size_t *size);
		bool LoadState(void *f);
		
	private:
		struct Rhythm
		{
			uint8_t	pan;		// ς
			int8_t	level;		// 傤
			int		volume_l;		// 傤Ă
#ifdef USE_FMGEN_STEREO
			int		volume_r;		// 傤Ă
#endif
			int16_t*	sample;		// Ղ
			uint32_t	size;		// 
			uint32_t	pos;		// 
			uint32_t	step;		// ĂՂ
			uint32_t	rate;		// Ղ̂[
		};

		void	RhythmMix(Sample* buffer, uint32_t count);

	// Y֌W
		Rhythm	rhythm[6];
		int8_t	rhythmtl;		// YŜ̉
		int		rhythmtvol_l;
#ifdef USE_FMGEN_STEREO
		int		rhythmtvol_r;
#endif
		uint8_t	rhythmkey;		// ỸL[
	};
#endif /* BUILD_OPNA */

#ifdef BUILD_OPNB
	//	YM2610/B(OPNB) ---------------------------------------------------
	class OPNB : public OPNABase
	{
	public:
		OPNB();
		virtual ~OPNB();

		bool	Init(uint32_t c, uint32_t r, bool = false,
					 uint8_t *_adpcma = 0, int _adpcma_size = 0,
					 uint8_t *_adpcmb = 0, int _adpcmb_size = 0);

		bool	SetRate(uint32_t c, uint32_t r, bool = false);
		void 	Mix(Sample* buffer, int nsamples);

		void	Reset();
		void 	SetReg(uint32_t addr, uint32_t data);
		uint32_t	GetReg(uint32_t addr);
		uint32_t	ReadStatusEx();

		void	SetVolumeADPCMATotal(int db_l, int db_r);
		void	SetVolumeADPCMA(int index, int db_l, int db_r);
		void	SetVolumeADPCMB(int db_l, int db_r);

//		void	SetChannelMask(uint32_t mask);

	private:
		struct ADPCMA
		{
			uint8_t	pan;		// ς
			int8_t	level;		// 傤
			int		volume_l;		// 傤Ă
#ifdef USE_FMGEN_STEREO
			int		volume_r;		// 傤Ă
#endif
			uint32_t	pos;		// 
			uint32_t	step;		// ĂՂ

			uint32_t	start;		// Jn
			uint32_t	stop;		// I
			uint32_t	nibble;		//  4 bit
			int		adpcmx;		// ϊp
			int		adpcmd;		// ϊp
		};

		int		DecodeADPCMASample(uint32_t);
		void	ADPCMAMix(Sample* buffer, uint32_t count);
		static void InitADPCMATable();

	// ADPCMA ֌W
		uint8_t*	adpcmabuf;		// ADPCMA ROM
		int		adpcmasize;
		ADPCMA	adpcma[6];
		int8_t	adpcmatl;		// ADPCMA Ŝ̉
		int		adpcmatvol_l;
#ifdef USE_FMGEN_STEREO
		int		adpcmatvol_r;
#endif
		uint8_t	adpcmakey;		// ADPCMA ̃L[
		int		adpcmastep;
		uint8_t	adpcmareg[32];

		static int jedi_table[(48+1)*16];

		Channel4 ch[6];
	};
#endif /* BUILD_OPNB */

#ifdef BUILD_OPN2
	//	YM2612/3438(OPN2) ----------------------------------------------------
	class OPN2 : public OPNBase
	{
	public:
		OPN2();
		virtual ~OPN2() {}

		bool	Init(uint32_t c, uint32_t r, bool=false, const char* =0);
		bool	SetRate(uint32_t c, uint32_t r, bool);

		void	Reset();
		void 	Mix(Sample* buffer, int nsamples);
		void 	SetReg(uint32_t addr, uint32_t data);
		uint32_t	GetReg(uint32_t addr);
		uint32_t	ReadStatus() { return status & 0x03; }
		uint32_t	ReadStatusEx() { return 0xff; }

		void	SetChannelMask(uint32_t mask);

	private:
		void	SetStatus(uint32_t bit);
		void	ResetStatus(uint32_t bit);

		uint32_t	fnum[3];
		uint32_t	fnum3[3];
		uint8_t	fnum2[6];

	// `ԗp[N
		int32_t	mixc, mixc1;

		Channel4 ch[3];
	};
#endif /* BUILD_OPN2 */
}

// ---------------------------------------------------------------------------

inline void FM::OPNBase::RebuildTimeTable()
{
	int p = prescale;
	prescale = -1;
	SetPrescaler(p);
}

inline void FM::OPNBase::SetVolumePSG(int db_l, int db_r, int ptn)
{
	psg.SetVolume(db_l, db_r, ptn);
}

#endif // FM_OPNA_H
